package xpug.kata.birthday_greetings;

import static org.junit.Assert.*;

import java.io.FileNotFoundException;
import java.io.IOException;
import java.text.ParseException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import javax.mail.MessagingException;
import javax.mail.internet.AddressException;

import org.junit.Test;

public class BirthdayServiceTest {

	@Test
	public void testSendGreetings() throws Exception {
		final String miloesBirthday = "10/12/2009";
		
		EmployeeFacade mockEmploeeFacade = new EmployeeFacade(){
			public List<Employee> loadEmployees() throws FileNotFoundException,
					IOException, ParseException {
				return Arrays.asList(new Employee("Milo", "", miloesBirthday, ""));
			}
		};
		
		
		final List<Greeting> sentGreetings = new ArrayList<Greeting>();
		GreetingsFacade mockGreetingsFacade = new GreetingsFacade(){
			public void send(Greeting greeting) throws AddressException, MessagingException {
				sentGreetings.add(greeting); 
			}
			
		};
		
		new BirthdayService(mockEmploeeFacade, mockGreetingsFacade).sendGreetings(new OurDate(miloesBirthday));
		assertEquals("Happy Birthday, dear Milo!", sentGreetings.get(0).getBody());
	}

}
