package xpug.kata.birthday_greetings;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.text.ParseException;
import java.util.ArrayList;
import java.util.List;

public class FileSystemEmployeeFacadeAdapter implements EmployeeFacade {
	
	final String fileName;

	public FileSystemEmployeeFacadeAdapter(String fileName) {
		this.fileName = fileName;
	}

	public List<Employee> loadEmployees()
			throws FileNotFoundException, IOException, ParseException {
		BufferedReader in = new BufferedReader(new FileReader(fileName));
		String str = "";
		str = in.readLine(); // skip header

		ArrayList<Employee> employees = new ArrayList<Employee>();
		while ((str = in.readLine()) != null) {
			String[] employeeData = str.split(", ");
			Employee employee = new Employee(employeeData[1], employeeData[0],
					employeeData[2], employeeData[3]);
			employees.add(employee);
		}
		return employees;
	}

}
